#include "types.h"
#include "param.h"
#include "memlayout.h"
#include "loongarch.h"
#include "defs.h"

__attribute__ ((aligned (16))) char stack0[4096 * NCPU];
volatile static int started = 0;

// start() jumps here in supervisor mode on all CPUs.
void
main()
{
  if(cpuid() == 0){
    consoleinit();
    printfinit();
    kinit();         
    vminit();        // create kernel page table
    procinit();    
    trapinit();    
    apic_init();
    extioi_init();
    binit();         
    iinit();         
    fileinit();     
    userinit();      
    __sync_synchronize();
    started = 1;
    printf("\nxv6 init successfully \n");
    printsys();
  } else {
    while(started == 0)
      ;
    __sync_synchronize();
    printf("hart %d starting\n", cpuid());
  }

  scheduler();        
}
