//
// ramdisk that uses the disk image loaded by qemu -initrd fs.img
//

#include "types.h"
#include "loongarch.h"
#include "defs.h"
#include "param.h"
#include "memlayout.h"
#include "spinlock.h"
#include "sleeplock.h"
#include "fs.h"
#include "buf.h"
#include "ramdisk.h"
#define RAMDISK 0x04000000
#define B_DIRTY 0x1
#define B_VALID 0x2

void
ramdiskinit(void)
{
}

// If B_DIRTY is set, write buf to disk, clear B_DIRTY, set B_VALID.
// Else if B_VALID is not set, read buf from disk, set B_VALID.
void
ramdiskrw(struct buf *b,int w)
{
   uint64 diskaddr = b->blockno * BSIZE;
//   char *addr = (char *)RAMDISK + diskaddr;
  char *addr = (char *)fs_img + diskaddr;
  if(!w && !b->valid)
	  memmove(b->data, addr, BSIZE);
  else if (w)
	  memmove(addr, b->data, BSIZE);
}